#ifndef __COMPILER_H__
#define __COMPILER_H__

#ifdef __IMAGECRAFT__


// choose your AVR device here
#include <iom128v.h>

#include <macros.h>

	#define SPCR	SPCR0
	#define SPIE	SPIE0
	#define SPE		SPE0
	#define DORD	DORD0
	#define MSTR	MSTR0
	#define CPOL	CPOL0
	#define CPHA	CPHA0
	#define SPR1	SPR01
	#define SPR0	SPR00
	#define SPSR	SPSR0
	#define SPI2X	SPI2X0
	#define SPDR	SPDR0
	#define SPSR	SPSR0
	#define SPIF	SPIF0
	#define SPDR	SPDR0
#define sbi(io_reg, bit_pos)  	io_reg |= 1<< bit_pos
#define cbi(io_reg, bit_pos)  	io_reg &= ~(1<< bit_pos)
#define outp(value, io_reg)  	io_reg = value
#define nop()		   asm volatile ("nop\n nop\n nop\n nop\n");


//#define outp(val, reg)  (reg = val)
//#define inp(reg)        (reg)

//#define cli()           CLI()
//#define sei()           SEI()
//#define cbi(reg, bit)   (reg &= ~BIT(bit))
//#define sbi(reg, bit)   (reg |= BIT(bit))

//#define SIGNAL(x)       void x(void)  

//#define nop() NOP()

//#define _BV(x)	   (1<<x)


#else /* --- GCC --- */

#include <avr/interrupt.h>
#include <avr/io.h>

#define nop() asm volatile("nop\n\t"::);
#define cbi(reg, bit)   (reg &= ~_BV(bit))
#define sbi(reg, bit)   (reg |= _BV(bit))

	#define SPCR	SPCR0
	#define SPIE	SPIE0
	#define SPE		SPE0
	#define DORD	DORD0
	#define MSTR	MSTR0
	#define CPOL	CPOL0
	#define CPHA	CPHA0
	#define SPR1	SPR01
	#define SPR0	SPR00
	#define SPSR	SPSR0
	#define SPI2X	SPI2X0
	#define SPDR	SPDR0
	#define SPSR	SPSR0
	#define SPIF	SPIF0
	#define SPDR	SPDR0
//#define sbi(io_reg, bit_pos)  	io_reg |= 1<< bit_pos
//#define cbi(io_reg, bit_pos)  	io_reg &= ~(1<< bit_pos)
//#define outp(value, io_reg)  	io_reg = value
//#define nop()		   asm volatile ("nop\n nop\n nop\n nop\n");


#endif /* Compiler Used */



#endif /* __COMPILER_H__ */

